'
' Creado por SharpDevelop.
' Usuario: Germn Carrillo (GeoTux)
' Fecha: 01/08/2008
' Hora: 09:57 a.m.
' 
' Para cambiar esta plantilla use Herramientas | Opciones | Codificacin | Editar Encabezados Estndar
'

Public Partial Class frmIdentificar
	Inherits Form
	
	
	'Variables globales
	Private mwMapa As AxMapWinGIS.AxMap 
	Private mwPoint As New MapWinGIS.PointClass 
	Private sShapefileSeleccionado as String = "" 'Para recordar capa de inters tras evento MouseDown
	Private Shared pInstancia as frmIdentificar 'Para el patrn Singleton
		
		
	'Constructor privado
	Private Sub New()		
		Me.InitializeComponent()				
	End Sub
	
	
	'Funcin pblica y compartida o esttica para el patrn Singleton
	Public Shared Function ObtenerInstancia() as frmIdentificar 
		
		If pInstancia Is Nothing Then
			pInstancia = New frmIdentificar()
		End If	
		
		Return pInstancia 
		
	End Function
	
	
	'Carga las capas del mapa al control cboCapas
	Private Sub CargarCapasACombo()
		
		dim i as integer
		If mwMapa.NumLayers = 0 Then
			msgbox ("Debes cargar al menos una capa al mapa.",MsgBoxStyle.OkOnly,"Identificar elementos espaciales")			
		Else
			For i = 0 To mwMapa.NumLayers -1
				cboCapas.Items.Add (mwMapa.get_layerName(i))			
			Next
		End If
		
	End Sub
	
	
	'Inicializa las variables globales y los controles de la interfaz de la herramienta	
	Public Sub Inicializar(ByVal Mapa As AxMapWinGIS.AxMap, pPuntoPantalla As MapWinGIS.Point)
		
		'Inicializar variables globales
		mwMapa = Mapa
		mwPoint = pPuntoPantalla
		
		'Controles
		lblError.Visible = False
		lstAtributos.Visible = False
		lstAtributos.Clear()
		lstAtributos.Columns.Add("Campo",100)
		lstAtributos.Columns.Add("Valor",177)
		lstAtributos.GridLines = True
		cboCapas.Items.Clear()
		CargarCapasACombo()
		
		'Seleccionar el shapefile si se encuentra an en la lista de capas.
		'   Esto permite obtener de nuevo los atributos de la capa seleccionada
		'   aun picando varias veces en el mapa.
		If cbocapas.Items.Contains(sShapefileSeleccionado) Then
			cbocapas.SelectedItem = sShapefileSeleccionado			
		End If
		
	End Sub
	
	
	'Evento para controlar el cambio de capa de inters
	Sub CboCapasSelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)			
		
		'Controles
		lstAtributos.Items.Clear()
		lstAtributos.Visible = False
		lblError.Visible=false
		
		sShapefileSeleccionado = cbocapas.SelectedItem 'Para recordar la capa seleccionada
		ValidarInterseccion(mwmapa.get_GetObject(cboCapas.SelectedIndex)) 'Llamado a funcin principal
		
	End Sub
	
	
	'Funcin principal que se encarga de realizar la interseccin de geometras
	Private Sub ValidarInterseccion(mwShapefile as MapWinGIS.Shapefile)
		
		'Manejar la tolerancia dependiendo del tipo de geometra
		Dim iTolerancia As Integer = 0		
		If mwShapefile.ShapefileType = Mapwingis.ShpfileType.SHP_POLYGON Or _
			mwShapefile.ShapefileType = Mapwingis.ShpfileType.SHP_POLYGONM Or _
			mwShapefile.ShapefileType = Mapwingis.ShpfileType.SHP_POLYGONZ Then
		 	iTolerancia = 0
		Else 'Multipunto, Punto o Polilnea 
			iTolerancia = 3 'Valor en pixeles
		End if
		               
		'Definir un objeto Extent para realizar la interseccin de geometras
        Dim pxMin As Double, pxMax As Double, pyMin As Double, pyMax As Double
        Dim miExtent As New MapWinGIS.Extents
        mwMapa.PixelToProj(mwPoint.x - iTolerancia, mwPoint.y - iTolerancia, pxMin, pyMin)
        mwMapa.PixelToProj(mwPoint.x + iTolerancia, mwPoint.y + iTolerancia, pxMax, pyMax)
        miExtent.SetBounds(pxMin, pyMin, 0, pxMax, pyMax, 0)
                                
        'Intersectar elementos con el cuadrado o el punto definidos anteriormente
        Dim valor As Object
        Dim sNombreCampo as String 
        Dim aShapesSeleccionados() As Integer 
        Dim i As Integer, n as Integer         
                
        If mwShapefile Is Nothing Then Exit Sub                       
        
        If mwShapefile.SelectShapes(miExtent, 0, MapWinGIS.SelectMode.INTERSECTION, aShapesSeleccionados) Then
        	
        	If aShapesSeleccionados.Length > 1 Then	'Ms de un elemento seleccionado
        		
				lblError.Visible = True 
				lblError.Text = "Se ha encontrado ms de un elemento espacial en la capa " & _
							cboCapas.SelectedItem & _
							" que corresponde al punto seleccionado en el mapa." & vbCrlf & vbCrlf & _
							"Selecciona otro punto en el mapa."
				lstAtributos.Visible = false        	
        		        		
        	Else 'Un elemento seleccionado
        	        	
	        	'Visibilidad de controles
	        	lblError.Visible = False
	        	lstAtributos.Visible=True 
	        	Dim lvItem As ListViewItem        	
	        	
	        	'Cargar datos al ListView
	            For i = 0 To UBound(aShapesSeleccionados)
	            	            	            	
	                For n = 0 To mwShapefile.NumFields - 1
	                    
	                    valor = mwShapefile.CellValue(n, aShapesSeleccionados(i))
	                    sNombreCampo = mwShapefile.Field(n).Name
	                
	                	If Not(sNombreCampo.ToUpper().Contains("SHAPE_")) Then
	                    	lvItem = New ListViewItem(sNombreCampo)
	        				lvItem.SubItems.Add(Valor)
	        				lstAtributos.Items.Add(lvItem)
	        			End If
	        			
	                Next n
	                
	            Next                                
	            
	        End If
	        
        Else 'No hay datos en la capa de inters que coincidan con el punto seleccionado        	
        	
			lblError.Visible = True 
			lblError.Text = "No se ha encontrado informacin en la capa " & _
							cboCapas.SelectedItem & _
							" que corresponda al punto seleccionado en el mapa."
			lstAtributos.Visible = false        	
        	
        End If
        
	End Sub
		
		
	'Cerrar ventana
	Sub BtnCerrarClick(ByVal sender As Object, ByVal e As EventArgs)
		Me.Close()
	End Sub
	
	
	'Evento que borra el punto dibujado sobre el mapa al cerrar la ventana
	Private Sub frmIdentificar_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		
		mwMapa.ClearDrawings() 'Limpia el punto dibujado para representar la seleccin del usuario
		pInstancia = Nothing 'Devuelve el objeto pInstancia a Nothing para el patrn Singleton
		
	End Sub
	
End Class
